#ifndef UNSUPERVISED_RBM_PROBLEMS_BARSANDSTRIPESClassifications_H
#define UNSUPERVISED_RBM_PROBLEMS_BARSANDSTRIPESClassifications_H

#include  <shark/Data/Dataset.h>
#include  <shark/LinAlg/Base.h>
namespace shark{

class BarsAndStripesClassification{
private:
	LabeledData<RealVector,unsigned int> m_data;
public:
	BarsAndStripesClassification(){
		std::vector<RealVector> data(320,RealVector(16));
		std::vector<unsigned int> label(320);
		RealVector line(4);
		for(std::size_t k = 0; k != 10; ++k){
			for(size_t x=0; x != 16; x++) {
				for(size_t j=0; j != 4; j++) {
					bool val = (x & (1<<j)) > 0;
					line(j) = val;
					if(Rng::coinToss(0.3))
						line(j) = !val;
				}

				for(int i=0; i != 4; i++) {
					subrange(data[x+k*16],i*4 ,i*4 + 4) = line;
				}
				for(int i=0; i != 4; i++) {
					for(int l=0; l<4; l++) {
						data[x+k*16+160](l*4 + i) = line(l);
					}
				}
				label[x+k*16] = 1; 
				label[x+k*16+160] = 0; 
			}
		}
		m_data = createLabeledDataFromRange(data,label);
	}
	///Returns all input pattern of the BarsAndStripes problem
	LabeledData<RealVector,unsigned int> data() const{
		return m_data;
	};

	///returns the dimensionality of the data
	std::size_t inputDimension() const {
		return 16;
	}
};

}
#endif
